import es
import langlib
import playerlib

info = es.AddonInfo() 
info.name     = "Ace Rates" 
info.version  = "4.0" 
info.url      = "http://forums.mattie.info/cs/forums/viewtopic.php?t=13243" 
info.author   = "Ace Rimmer"
info.basename = "ace_rates"

#Server/Global Varibles
ace_min_rate = 7500
ace_min_cmdrate = 30
ace_min_updaterate = 20
#Set max rate(s)-1 for server. eg: for 100 you'd write 99.
ace_max_rate = 30000
ace_max_cmdrate = 100
ace_max_updaterate = 100
ace_rate_kick = False			#True if you want to simply kick raters, else False
ace_rate_announce = True		#False=No Announcing, True=Announce rate adjustment to player chat
text = None

def load():
    global text
    text = langlib.Strings(es.getAddonPath("ace_rates") + "/language.ini")
    if not es.exists("command", "rates"):
        es.regsaycmd("rates", "ace_rates/aceRateCmd", "Get All/Single Persons Rates")
    es.msg("#multi", text("loaded"))

def unload():
	es.msg("#multi", text("unloaded"))

def aceRateCheck(uid):
  	player = playerlib.getPlayer(uid)
  	values = {}
	tokens = {}
	tokens['user'] = player.get("name")
	tokens['rate'] = es.getclientvar(uid, 'rate')
	tokens['cmdrate'] = es.getclientvar(uid, 'cl_cmdrate')
	tokens['updaterate'] = es.getclientvar(uid, 'cl_updaterate')
	tokens['type'] = "rate"
	if int(tokens['rate']) < ace_min_rate:
		if ace_rate_announce:
			es.msg("#multi", text("rate: all", tokens))
			if ace_rate_kick:
				es.msg("#multi", text("kick", tokens))
		if ace_rate_kick:
			player.kick(text("kickedlow", tokens, player.get("lang")))
	if int(tokens['rate']) > ace_max_rate:
		if ace_rate_announce:
			es.msg("#multi", text("rate: all", tokens))
			if ace_rate_kick:
				es.msg("#multi", text("kick", tokens))
		if ace_rate_kick:
			player.kick(text("kickedlow", tokens, player.get("lang")))
	tokens['type'] = "cl_cmdrate"
	if int(tokens['cmdrate']) < ace_min_cmdrate:
		if ace_rate_announce:
			es.msg("#multi", text("rate: all", tokens))
			if ace_rate_kick:
				es.msg("#multi", text("kick", tokens))
		if ace_rate_kick:
			player.kick(text("kickedlow", tokens, player.get("lang")))
	if int(tokens['cmdrate']) > ace_max_cmdrate:
		if ace_rate_announce:
			es.msg("#multi", text("rate: all", tokens))
			if ace_rate_kick:
				es.msg("#multi", text("kick", tokens))
		if ace_rate_kick:
			player.kick(text("kickedlow", tokens, player.get("lang")))
	tokens['type'] = "cl_updaterate"
	if int(tokens['updaterate']) < ace_min_updaterate:
		if ace_rate_announce:
			es.msg("#multi", text("rate: all", tokens))
			if ace_rate_kick:
				es.msg("#multi", text("kick", tokens))
		if ace_rate_kick:
			player.kick(text("kickedlow", tokens, player.get("lang")))
	if int(tokens['updaterate']) > ace_max_updaterate:
		if ace_rate_announce:
			es.msg("#multi", text("rate: all", tokens))
			if ace_rate_kick:
				es.msg("#multi", text("kick", tokens))
		if ace_rate_kick:
			player.kick(text("kickedlow", tokens, player.get("lang")))

def aceRate(plyname, actid):
	plyid = es.getuserid(plyname)
	tokens = {}
	tokens['user'] = plyname
	tokens['rate'] = es.getclientvar(plyid, 'rate')
	tokens['cmdrate'] = es.getclientvar(plyid, 'cl_cmdrate')
	tokens['updaterate'] = es.getclientvar(plyid, 'cl_updaterate')
	es.tell(actid, text("rate", tokens))

def aceRateAll(actid):
	playerList = playerlib.getPlayerList("#all")
	for ply in playerList:
		aceRate(ply.get("name"), int(actid))

def aceRateCmd():
	if es.getargc() > 1:
		if es.getuserid(es.getargv(1)) > 0:
			player = playerlib.getPlayer(es.getuserid(es.getargv(1)))
			aceRate(player.get("name"), es.getcmduserid())
		else:
			player = playerlib.getPlayer(es.getcmduserid())
			es.tell(es.getcmduserid(), text("no match", None, player.get("lang")))
	else:
		aceRateAll(es.getcmduserid())

def aceBotCheck(uid, uteam):
	if uteam > 1:
		if not es.isbot(uid):
			aceRateCheck(uid, uteam)

def acePrint(uId):
	if es.getplayerteam(uId) > 1:
		if not es.isbot(uId):
			aceRateCheck(uId)

def player_spawn(event_var):
	acePrint(event_var['userid'])
